﻿using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Fiddler;

namespace AnyWhere
{
    public partial class frmSelectLocation : Form
    {
        private string strLocation = String.Empty;
        private GoAnywhere _myOwner = null;
              
        public frmSelectLocation(GoAnywhere oOwner)
        {
            _myOwner = oOwner;            
            InitializeComponent();
            StartPosition = FormStartPosition.CenterScreen;
        }

        private void frmSelectLocation_Load(object sender, EventArgs e)
        {
            Utilities.SetCueText(cbxLocations, "Latitude, Longitude, Precision, Elevation");
            
            cbxLocations.Items.Add("Paris: 48.858, 2.295, 50, 100");
            cbxLocations.Items.Add("Egypt: 29.977, 31.133, 50, 100");
            cbxLocations.Items.Add("IE: 47.64705, -122.13281, 100, 40");
            cbxLocations.Items.Add("NYNY: 40.6894, -074.0447, 100, 100");
            cbxLocations.Items.Add("NYNV:  36.10189, -115.175, 100, 100");
            cbxLocations.Items.Add("D.C.: 38.88933, -77.03516, 100,100");
            cbxLocations.Items.Add("Rome: 41.89017, 12.49227, 40, 40");
            cbxLocations.Items.Add("Sydney: -33.85836, 151.21488, 40, 40");

            string sLastEntry = FiddlerApplication.Prefs.GetStringPref("extensions.AnyWHERE.LastLocation", null);
            if (!String.IsNullOrEmpty(sLastEntry) && !cbxLocations.Items.Contains(sLastEntry))
            {
                cbxLocations.Items.Add(sLastEntry);
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            strLocation = cbxLocations.Text;
            FiddlerApplication.Prefs.SetStringPref("extensions.AnyWHERE.LastLocation", strLocation);
                        
            string sPlace = Utilities.TrimAfter(strLocation, ":");            
            lblStatus.Text = "Location set to: " + sPlace;
            _myOwner.SetOverrideLocation(strLocation);
        }

        private void cbxLocations_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && e.KeyCode == Keys.V)
            {
                string sClipText = Clipboard.GetText();
                sClipText = sClipText.Replace("\r\n", " ");
                cbxLocations.SelectedText = sClipText;
                e.SuppressKeyPress = true;
                e.Handled = true;
            }
        }

        private void pbGlobe_DoubleClick(object sender, EventArgs e)
        {
            Utilities.LaunchHyperlink("http://www.visualpharm.com/");
        }

        private void btnDisable_Click(object sender, EventArgs e)
        {
            lblStatus.Text = "Overrides disabled";
            _myOwner.SetOverrideLocation(null);
        }

        private void lnkIETestDrive_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {        
            Utilities.LaunchHyperlink("http://ie.microsoft.com/testdrive/html5/geolocation/default.html");
        }

        private void lnkFirefoxDemo_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {            
            Utilities.RunExecutable("firefox.exe", "http://html5demos.com/geo");
        }
    }
}
